/*
Copyright (C) 2006 - 2009 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef BOOKMARKS_20061122_H_
#define BOOKMARKS_20061122_H_

#include "DebuggerPluginInterface.h"
#include "Types.h"

class QMenu;
class QPoint;
class QPushButton;
class QSignalMapper;
class QTableWidget;
class QTableWidgetItem;
#include <QSet>

class Bookmarks : public QObject, public DebuggerPluginInterface {
	Q_OBJECT
	Q_INTERFACES(DebuggerPluginInterface)
	Q_CLASSINFO("author", "Evan Teran")
	Q_CLASSINFO("url", "http://www.codef00.com")

public:
	Bookmarks();
	
public:
	virtual QMenu *menu(QWidget *parent = 0);
	virtual QList<QAction *> cpu_context_menu();

public Q_SLOTS:
	void add();
	void del();
	void clear();
	void cellDoubleClicked(int row, int column);
	void mnuBookmarkCPU();

private Q_SLOTS:
	void shortcut(int index);
	void customContextMenuRequested(const QPoint &pos);

private:
	void add_address(edb::address_t address);

private:
	QMenu					*menu_;
	QPushButton				*button_add_;
	QPushButton				*button_del_;
	QPushButton				*button_clear_;
	QTableWidget			*table_;
	QSignalMapper			*signal_mapper_;
	QSet<edb::address_t>	entries_;
};

#endif
