/*
Copyright (C) 2006 - 2009 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "Register.h"

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
Register::Register() : valid_(false), value_(0) {
}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
Register::Register(const QString &name, edb::reg_t value, Type type, edb::address_t segmentBase) : valid_(true), name_(name), value_(value), type_(type), segment_base_(segmentBase) {
}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
Register::Register(const Register &other) : valid_(other.valid_), name_(other.name_), value_(other.value_), type_(other.type_), segment_base_(other.segment_base_) {
}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
Register &Register::operator=(const Register &rhs) {
	if(this != &rhs) {
		valid_ = rhs.valid_;
		name_ = rhs.name_;
		value_ = rhs.value_;
		type_ = rhs.type_;
		segment_base_ = rhs.segment_base_;
	}
	return *this;
}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
bool Register::operator==(const Register &rhs) const {
	if(!valid_ && !rhs.valid_) {
		return true;
	} else {
		return valid_ == rhs.valid_ && name_ == rhs.name_ && value_ == rhs.value_ && type_ == rhs.type_ && segment_base_ == rhs.segment_base_;
	}
}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
bool Register::operator!=(const Register &rhs) const {
	return !(*this == rhs);
}
